 # -*- coding: utf-8 -*-

from browser import window, document, console, ajax
from browser.session_storage import storage
import json

categories = [
	["Delivery", "Lieferung", "Dowóz", "Доставка"],
    ["In-place", "An Ort und Stelle", "Na miejscu", "На месте"]
]

language = None

LANG_KEY = 'current-language'
TRANSLATE_CLASS = '.to-translate'


# => CHANGE MENU LANGUAGE
def change_menu_lang(lang):
	try:
		names = storage[window.MENU_NAMES_ARR_KEY].split(',')

		for name in names:
			ID = 'hidden-menu-' + name
			document[ID].text = lang[name]

	except KeyError:
		console.log('Cannot change the menu language')


def change_orders_text(orders, lang):
	console.log("Amount of orders: ", storage[window.ORDERS_COUNT_KEY])

	for order in orders:
		category = order.select('.category')[0]
		category.text = lang['delivery-type'][0] if category.text in categories[0] else lang['delivery-type'][1]


# => CHANGE THE LANGUAGE
def change_lang(lang):

	# => CHANGE MENU LANGUAGE
	change_menu_lang(lang)

        if window.page == window.INDEX_FILE:
    		# => CHANGE THE ORDERS BOX TEXT
        	document['header'].text = lang['recent-orders']

           	if int(storage[window.ORDERS_COUNT_KEY]) == 0:
            		document['no-orders-yet'].text = lang['no-orders-yet']
                	document['no-orders-yet'].style.display = 'block';

            # => TODO ** ADD THE NUMBER OF ORDERS TO THE END OF A TEXT **
			document['total-orders'].text = lang['total-orders'] + ' ' + storage[window.ORDERS_COUNT_KEY]

            # => BY CLASS NAME
        	change_orders_text(document.select('.other-order-information'), lang)

        elif window.page == window.LOGIN_FILE:
            toTranslate = document.select(TRANSLATE_CLASS)

            for msg in toTranslate:
                classes = msg.attrs['class'].split(' ')

                try: ID = msg.attrs['id']
                except KeyError: pass

                try: msg.text = lang[ID]
                except KeyError: msg.text = lang[classes[0] if len(classes) > 0 else classes]

	# => REMOVE THE CLASS FROM LAST ELEMENT
	if len(document.select('img.current')) > 0:
            current_language = document.select('img.current')[0]
            current_language.classList.remove("current")

        # => ADD 'current' CLASS TO THE NEW ELEMENT
        if language is not None:
          	document[language].classList.add("current")

          	# => ADD TO THE SESSION STORAGE
          	storage[LANG_KEY] = language


def read(req, status=False):
    if status == True: messages = req
    else: messages = req.responseText

    # change_lang(json.loads(messages, strict=False))


def load_json(lang):
	try:
		value = storage[window.langKeyPattern(lang)]

		if value is not None or value != "":
			console.log("Changing language to " + lang + " - using saved language data set under key: " + window.langKeyPattern(lang))
			read(value, status=True)

	except KeyError:

            URL = '/languages/' + lang + '.json'

            # => CREATE A NEW AJAX REQUEST
            request = ajax.ajax()
            request.open('GET', URL, True)
            request.bind('complete', read)
            request.send()


def check():
	# => CHECK IF THE LANGUAGE VALUE IS NOT SET
	try:
		language = storage[LANG_KEY]
		load_json(storage[LANG_KEY])
	except KeyError:
		storage[LANG_KEY] = 'en'
        console.log("Current language: ", storage[LANG_KEY])


def show(e):
	global language

	ID = e.target.id
	language = ID
	json_file = load_json(ID)

	console.log('RES', json_file)



# => CHECK IF LAST LANGUAGE ISSET
check()

en = document['en']
pl = document['pl']
ru = document['ru']
ge = document['ge']

en.bind("click", show)
pl.bind("click", show)
ru.bind("click", show)
ge.bind("click", show)



